/* MailTweak internal component - Copyright (C) 2007, 2010 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://mailtweak.mozdev.org/ */
AM = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager)
SS = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService)
DS = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties)
PS = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService)
mailPref = PS.getBranch("mail.")
wizPref = PS.getBranch("extension.newaccount.")
domain = ""
elem = function (id) {
return id? document.getElementById(id) : null}
incoming = null
// existing servers...
pop3 = []
imap = []
none = []
name = []
login = []
// my UI prefs...
uipref = [
"type-list","in-list","no-id","out-list","no-smtp","settings"
]
block = [
"directory","directory-rel","hostname","realhostname","userName","realuserName","type","name","useremail","username","hostname","description"
]
load = function () {
if (opener.document.getElementById("accounttree")) {
with (elem("settings")) checked = true, hidden = true}
var aa = AM.accounts, n = aa.Count(), ss = []
for (var i = 0; i < n; ++i) {
try {
var a = aa.GetElementAt(i).QueryInterface(Components.interfaces.nsIMsgAccount)
var s = a.incomingServer
switch (s.type) {
case "pop3":
pop3.push([s.rootFolder.name, a.key])
break
case "imap":
imap.push([s.rootFolder.name, a.key])
break
case "none":
none.push([s.rootFolder.name, a.key])
break}
name.push(s.rootFolder.name)
login.push(s.username + "@@" + s.hostName)}
catch (ex) {}}
var sorter = function (a, b) {
return a[0] == b[0]? 0 : a[0] > b[0]? 1 : -1}
pop3.sort(sorter)
imap.sort(sorter)
none.sort(sorter)
var t = "pop3"
try {t = AM.defaultAccount.incomingServer.type} catch (ex) {}
elem("type-list").value = t
populate(window[t])
caption(t)
var pop = elem("out-list").firstChild
var aa = SS.smtpServers, ss = []
while (aa.hasMoreElements()) {
try {
var s = aa.getNext().QueryInterface(Components.interfaces.nsISmtpServer)
ss.push([s.description || s.displayname || s.hostname, s.key])}
catch (ex) {}}
ss.sort(function (a, b) {
return a[0] == b[0]? 0 : a[0] > b[0]? 1 : -1})
for (var i = 0, s; s = ss[i]; ++i) {
with (pop.appendChild(document.createElement("menuitem")))
setAttribute("label", s[0]), setAttribute("value", s[1])}
if (pop.lastChild.localName != "menuitem") pop.lastChild.hidden = true
pop.parentNode.value = ""
for (var i = 0, p, e; p = uipref[i]; ++i) {
e = elem(p)
switch (wizPref.getPrefType(p)) {
case 128:
e.checked = wizPref.getBoolPref(p)
break
case 64:
e.value = wizPref.getIntPref(p)
break
case 32:
e.value = wizPref.getCharPref(p)
break}
ui({target: e})}
document.documentElement.getButton("accept").disabled = true}
populate = function (ss) {
var pop = elem("in-list").firstChild
while (pop.lastChild.localName == "menuitem") pop.removeChild(pop.lastChild)
pop.lastChild.hidden = false
for (var i = 0, s; s = ss[i]; ++i) {
with (pop.appendChild(document.createElement("menuitem")))
setAttribute("label", s[0]), setAttribute("value", s[1])}
if (pop.lastChild.localName != "menuitem") pop.lastChild.hidden = true
pop.parentNode.value = ""}
caption = function (type) {
var c = elem("in-caption")
var t = type == "none"? c.getAttribute("localtext") : type.toUpperCase()
c.setAttribute("label", c.getAttribute("text").replace(/%/, t))}
accept = function () {
var type = elem("type-list").value
if (timer_v) clearTimeout(timer_v)
if (!validate2()) return false
var ok = true, v
if (!elem("no-id").checked) {
v = elem("email").value.trim()
ok = /^[a-zA-Z0-9.\-]+@[a-zA-Z0-9._%$#+-]+$/.test(v)
if (!ok) {
status("Email address is not valid")
elem("email").focus()}}
if (ok) {
v = elem("in-host").value.trim()
ok = /^[a-zA-Z0-9.\-]*$/.test(v)
if (!ok) {
status(type.toUpperCase() + " host name is not valid")
elem("in-host").focus()}}
if (ok && !elem("no-smtp").checked) {
v = elem("out-host").value.trim()
ok = /^[a-zA-Z0-9.\-]*$/.test(v)
if (!ok) {
status("SMTP host name is not valid")
elem("out-host").focus()}}
if (!ok) {
document.documentElement.getButton("accept").disabled = true
return false}
var s = null
try {s = AM.localFoldersServer} catch (ex) {}
if (!s) AM.createLocalMailAccount()
if (type == "none") {
var u = "nobody", h = "Local Folders"
for (var i = 1; login.indexOf(u + "@@" + h + "-" + i) >= 0; ++i) {}
h += "-" + i}
else var u = elem("user").value.trim(), h = elem("in-host").value.trim()
var temp = elem("in-list").value
if (temp) temp = AM.getAccount(temp)
var svr = AM.createIncomingServer(u, h, type)
svr.prettyName = elem("account").value
if (temp) copyPref(
"mail.server." + temp.incomingServer.key + ".","mail.server." + svr.key + ".",temp.incomingServer.serverURI,svr.serverURI)
svr.valid = true
var id = type == "none"? null : AM.createIdentity()
if (id) {
id.email = elem("email").value.trim()
if (temp) copyPref(
"mail.identity." + temp.defaultIdentity.key + ".","mail.identity." + id.key + ".",temp.incomingServer.serverURI,svr.serverURI)
id.valid = true}
var act = AM.createAccount()
if (id) act.addIdentity(id)
act.incomingServer = svr
if (!elem("no-smtp").checked) {
var smtp = SS.createSmtpServer()
smtp.hostname = elem("out-host").value.trim()
smtp.username = elem("user").value.trim()
var stemp = elem("out-list").value
if (stemp) copyPref(
"mail.smtpserver." + stemp + ".","mail.smtpserver." + smtp.key + ".","","")
var m = stemp? SS.getServerByKey(stemp).username.indexOf("@") > 0 : false
smtp.username = elem(m? "email" : "user").value
smtp.description = elem("account").value
id.smtpServerKey = smtp.key}
AM.saveAccountInfo()
for (var i = 0, p, e; p = uipref[i]; ++i) {
e = elem(p)
switch (wizPref.getPrefType(p)) {
case 128:
wizPref.setBoolPref(p, e.checked)
break
case 64:
wizPref.setIntPref(p, e.value)
break
case 32:
wizPref.setCharPref(p, e.value)
break}}
if (elem("settings").checked) {
incoming = svr
addEventListener("unload", settings, true)}}
copyPref = function (src, tgt, suri, turi) {
var spref = PS.getBranch(src), tpref = PS.getBranch(tgt)
var tt = spref.getChildList("", {})
for (var i = 0, t, v; t = tt[i]; ++i) {
if (block.indexOf(t) >= 0) continue
switch (spref.getPrefType(t)) {
case 128:
tpref.setBoolPref(t, spref.getBoolPref(t))
break
case 64:
tpref.setIntPref(t, spref.getIntPref(t))
break
case 32:
var v = spref.getCharPref(t)
if (suri && v.indexOf("mailbox://") == 0) v = v.replace(suri, turi)
tpref.setCharPref(t, v)
break}}}
settings = function () {
var w = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("mailnews:accountmanager")
if (w) {
w.NewAccount.select(incoming)
w.focus()}
else opener.parent.openDialog(
"chrome://messenger/content/AccountManager.xul","AccountManager","chrome,centerscreen,modal,titlebar",{server: incoming, selectPage: null})}
ui = function (event) {
var tgt = event.target, val = tgt.value, ok
var id = tgt.id || (tgt.parentNode.parentNode && tgt.parentNode.parentNode.id)
switch (id) {
case "account":
break
case "type-list":
ok = (val == "none")
elem("name").disabled = ok
elem("user").disabled = ok
elem("email").disabled = ok
with (elem("in-host")) disabled = ok, value = ""
with (elem("out-list")) disabled = ok, value = ""
with (elem("out-host")) disabled = ok, value = ""
with (elem("no-id")) checked = ok, disabled = ok
with (elem("no-smtp")) checked = ok, disabled = ok
populate(window[val])
caption(val)
break
case "in-list":
var a = val? AM.getAccount(val) : null
if (a) {
elem("in-host").value = a.incomingServer.hostName
var w = a.defaultIdentity
domain = w.email.replace(/^[^@]*@/, "")
elem("name").value = w.fullName}
var k = a? a.defaultIdentity.smtpServerKey : ""
elem("out-list").value = k
if (k) elem("out-host").value = SS.getServerByKey(k).hostname
break
case "in-host":
break
case "user":
elem("email").value = val? val.replace(/[^a-zA-Z0-9-+._%-]/g, "") + "@" + domain : ""
break
case "name":
case "email":
break
case "no-id":
var ok = tgt.checked
elem("name").disabled = ok
elem("email").disabled = ok
with (elem("no-smtp")) checked = ok, disabled = ok
ui({target: elem("no-smtp")})
break
case "out-list":
if (val) elem("out-host").value = SS.getServerByKey(val).hostname
break
case "out-host":
break
case "no-smtp":
if (tgt.getAttribute("readonly") == "true") tgt.checked = true
ok = tgt.checked
elem("out-list").disabled = ok
elem("out-host").disabled = ok
validate(true)
break
case "settings":
break
default:
}
if (id !== null) validate()}
addEventListener("command", ui, false)
addEventListener("input", ui, false)
status = function (txt) {
var s = elem("status")
 s.value = txt}
timer_v = null
validate = function (force) {
if (timer_v) clearTimeout(timer_v)
if (force) validate2()
else timer_v = setTimeout(validate2, 300)}
validate2 = function () {
status("")
ok = Boolean(elem("account").value)
if (elem("type-list").value != "none")
ok = ok && Boolean((elem("user").value)
&& Boolean(elem("in-host").value)
&& (Boolean(elem("out-host").value) || elem("no-smtp").checked))
if (name.indexOf(elem("account").value) >= 0) {
ok = false
status("An account with that name already exists")}
if (login.indexOf(elem("user").value + "@@" + elem("in-host").value) >= 0) {
ok = false
status("An account for " + elem("user").value + " on that server already exists")}
document.documentElement.getButton("accept").disabled = !ok
return ok}