/* MailTweak internal component - Copyright (C) 2007, 2010 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://mailtweak.mozdev.org/ */
EXPORTED_SYMBOLS = ["MailTweak_Defer"]
MailTweak_Defer = {
outbox: null,folder: null,busy: false,date: "",msgs: null,work: 0,client: null,MMS: Components.classes["@mozilla.org/messenger/mailboxservice;1"].getService(Components.interfaces.nsIMsgMessageService),SSN: Components.classes["@mozilla.org/messenger/services/session;1"].getService(Components.interfaces.nsIMsgMailSession),setup: function (msgs, client, when) {
if (this.busy) {
Components.utils.reportError("MailTweak_Defer: busy")
return}
this.busy = true
this.client = client
var obx = Components.classes["@mozilla.org/messengercompose/sendlater;1"].getService(Components.interfaces.nsIMsgSendLater).getUnsentMessagesFolder(null)
var dfr = null
try {dfr = obx.getChildNamed("Deferred")} catch (ex) {}
if (!dfr) {
obx.createSubfolder("Deferred", null)
dfr = obx.getChildNamed("Deferred")}
this.folder = dfr
this.outbox = obx
var immed = Boolean(msgs)
&& Boolean(msgs[0])
&& (msgs[0].indexOf(dfr.baseMessageURI) == 0)
if (when) {
if (when instanceof Date) {
if (when <= new Date) when = null}
else {
Components.utils.import("resource://mailtweak/defer-preset.js")
try {when = (new MailTweak_DeferPreset(when.toString())).when}
catch (ex) {
Components.utils.reportError("MailTweak Defer: bad preset " + ex )
when = null}}}
if (!when) {
var dlg = {immed: immed, ok: false, time: null}
client.window.openDialog(
"chrome://mailtweak/content/defer.xul","mailtweak:defer","chrome,centerscreen,modal",dlg)
if (!dlg.ok || !dlg.time) {
this.busy = false
return}
when = dlg.time}
this.client.status = "Deferring..."
// RFC2822 date...
var pad = function (n) n > 9? n : "0" + n
var zone = function (m) {
var z = m < 0? "+" : "-"
m = Math.abs(m)
return z + pad(Math.floor(m / 60)) + pad(m % 60)}
var d = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"][when.getDay()] + ", "
+ pad(when.getDate()) + " "
+ ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
[when.getMonth()] + " "
+ when.getFullYear() + " "
+ pad(when.getHours()) + ":"
+ pad(when.getMinutes()) + ":"
+ pad(when.getSeconds()) + " "
+ zone(when.getTimezoneOffset())
this.date = d
if (client.mode == 1) {
this.SSN.AddFolderListener(this, 1)
client.send()}
else {
this.msgs = []
this.work = msgs.length
for (var i = 0, m; m = msgs[i]; ++i) {
this.msgs.push(this.MMS.messageURIToMsgHdr(m))
this.setup1(m)}}},setup1: function (uri, date) {
Components.classes["@mozilla.org/messenger;1"].createInstance(Components.interfaces.nsIMessenger).messageServiceFromURI(uri).streamMessage(uri, this, null, null, false, "", false )},OnItemAdded: function (folder, msg) {
if (folder != this.outbox) return
msg instanceof Components.interfaces.nsIMsgDBHdr
this.msgs = [msg]
this.setup1(folder.getUriForMsg(msg))
this.SSN.RemoveFolderListener(this)},onStartRequest: function () {this._data = ""},onStopRequest: function () {
this._data = this._data.replace(/\r\nX-MailTweak-Defer: \d/g, "").replace(/\r\nDate:/, "\r\nX-MailTweak-Defer: " + MailTweak_Defer.client.mode
+ "\r\nDate: "
+ MailTweak_Defer.date
+ "\r\nX-Date-Was:")
var tmp = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile)
tmp.append("temp.eml")
tmp.createUnique(0, 0777)
var os = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream)
os.init(tmp, 0x2a, 0777, 0)
os.write(this._data, this._data.length)
os.flush()
os.close()
Components.classes["@mozilla.org/messenger/messagecopyservice;1"].getService(Components.interfaces.nsIMsgCopyService).CopyFileMessage(tmp.clone(), MailTweak_Defer.folder, null, false, 1, "", this, null)},onDataAvailable: function (req, ctx, ins, ofs, n) {
var ss = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream)
ss.init(ins)
this._data += ss.read(ss.available())},QueryInterface: function (aIId, instance) {
if (aIId.equals(Components.interfaces.nsIStreamListener)
|| aIId.equals(Components.interfaces.nsISupports)) return this
throw Components.results.NS_ERROR_NO_INTERFACE},OnStopCopy: function (status) {
if (--MailTweak_Defer.work > 0) return
for each (var m in MailTweak_Defer.msgs) {
try {
m.folder.getDBFolderInfoAndDB({}).DeleteMessage(m.messageKey, null, true)}
catch (ex) {Components.utils.reportError(ex)}}
var n = MailTweak_Defer.msgs.length
MailTweak_Defer.client.status = (n == 1)? "Message deferred"
: "% messages deferred".replace(/%/, n)
MailTweak_Defer.busy = false
MailTweak_Defer.client.deferrer.observe()
MailTweak_Defer.client.finish()},OnProgress: function () {},OnStartCopy: function () {},SetMessageKey: function (k) {},toString: function () "[object MailTewak_Defer]"}
