/* MailTweak internal component - Copyright (C) 2007, 2010 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://mailtweak.mozdev.org/ */
const Cc = Components.classes
const Ci = Components.interfaces
const Cr = Components.results
const Cu = Components.utils
if (Cu.import) Cu.import("resource://gre/modules/XPCOMUtils.jsm")
NSGetModule = function (aCompMgr, aFileSpec) {
if (Cu.import) return XPCOMUtils.generateModule([MailTweakService])
var my = MailTweakService
return {
registerSelf: function (mgr, file, loc, type) {
mgr.QueryInterface(Ci.nsIComponentRegistrar).registerFactoryLocation(my.classID, my.classDescription, my.contractID, file, loc, type)
var CM = Components.classes["@mozilla.org/categorymanager;1"].getService(Ci.nsICategoryManager)
for each (var c in my._xpcom_categories) {
CM.addCategoryEntry(
c.category,c.entry || my.classDescription,(c.service? "service,":"") + my.contractID,true,true)}},getClassObject: function (mgr, cid, iid) {
if (!iid.equals(Ci.nsIFactory)) throw Cr.NS_ERROR_NOT_IMPLEMENTED
if (!cid.equals(my.classID)) throw Cr.NS_ERROR_NO_INTERFACE
return my._xpcom_factory},canUnload: function () {return false}}}
MailTweakService = {
classDescription: "MailTweak",contractID: "@rod.whiteley/mailtweak;1",classID: Components.ID("{8547513e-4f5a-11dc-8314-f800200c9a6b}"),_xpcom_categories: [
{category: "app-startup", service: true},{category: "command-line-handler", entry: "m-mailtweak-l"},{category: "command-line-argument-handlers", entry: "m-mailtweak-a"}
],_xpcom_factory: {createInstance: function () {return MailTweakService}},QueryInterface: function (iid) {
if (iid.equals(Ci.nsISupports)
|| iid.equals(Ci.nsIObserver)
|| iid.equals(Ci.nsICommandLineHandler)) return this
throw Cr.NS_ERROR_NO_INTERFACE},get prototype () {return this},obs: Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService),pref: Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService),prefBranch: null,_onetime: false,_cleanup: [],about: function (wdw) {
var v0 = Components.classes["@mozilla.org/extensions/manager;1"].getService(Ci.nsIExtensionManager).getItemForID("mail-tweak@rod.whiteley").version
this._about = (this.prefBranch.getCharPref("version") != v0)
if (this._about) {
this.prefBranch.setCharPref("version", v0)
this.prefBranch.setCharPref("_option", "")
this.pref.savePrefFile(null)
this._options = false
wdw.openDialog(
"chrome://mailtweak/content/about.xul","_blank","chrome,modal,centerscreen",this)
if (this._options) wdw.openDialog(
"chrome://mailtweak/content/options.xul","_blank","chrome,modal,centerscreen",null)}},_appliedURI: null,applyStyle: function () {
if (this._appliedURI) {
Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService).unregisterSheet(this._appliedURI, 0)
this._appliedURI = null}
var css = ""
if (this.prefBranch.getBoolPref("addrlines"))
css += "#MsgHeadersToolbar {min-height: 0 !important;}"
if (this.prefBranch.getBoolPref("splitter"))
css += "splitter[state=collapsed]:hover {background-color: Highlight !important;}"
if (this.prefBranch.getBoolPref("treefont")) {
var size = this.prefBranch.getIntPref("treefont.size")
if (size) css += "treechildren%7Bfont-size%3A" + String(size) + "px%3B%7D"}
if (css) {
this._appliedURI = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService).newURI("data:text/css," + css, "", null)
Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService).loadAndRegisterSheet(this._appliedURI, 0)}},applyContentStyle: function () {
var css = ".mailtweak-webpage {color: orange;}"
var uri = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService).newURI("data:text/css," + css, "", null)
Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService).loadAndRegisterSheet(uri, 1)},observe: function (subject, topic, data) {
switch (topic) {
case "app-startup":
this.obs.addObserver(this, "domwindowopened", false)
this.obs.addObserver(this, "em-action-requested", false)
this.obs.addObserver(this, "network:offline-status-changed", false)
break;
case "domwindowopened":
subject.MailTweakService = this
if (this._onetime) return
this.prefLoad()
this.applyStyle()
this.applyContentStyle()
TagTools.init()
if (this.prefBranch.getBoolPref("prefcache"))
subject.setTimeout(
function () {MailTweakService.prefSave(true)},this.prefBranch.getIntPref("prefcache.delay"))
var self = this
subject.addEventListener("load",function (event) {
if (MailTweakService._onetime) return
if (subject.atStartupRestoreTabs) MailTweakService._onetime = true
var s = subject.loadExtraTabs? "loadExtraTabs":"SetFocusThreadPane"
var sftp = subject[s]
if (!sftp) return
subject[s] = function () {
sftp()
subject.setTimeout(function () {self.about(subject)}, 0)
subject[s] = sftp
Deferrer.init()}},false)
break;
case "em-action-requested":
var item = subject.QueryInterface(Ci.nsIUpdateItem)
if (item.id != "mail-tweak@rod.whiteley") return
switch (data) {
case "item-disabled":
this._prefCache = null
case "item-uninstalled":
this._prefCache = []
var b = this.prefBranch
var cc = b.getChildList("", {})
for each (var c in cc) {
var t = b.getPrefType(c)
var v = (t == 32)? b.getCharPref(c) : (t == 64)? b.getIntPref(c) : b.getBoolPref(c)
this._prefCache.push({name: c, type: t, value: v})}
b.deleteBranch("")
break;
case "item-cancel-action":
if (!this._prefCache) return
var b = this.prefBranch
for each (var c in this._prefCache) {
if (c.type == 32) b.setCharPref(c.name, c.value)
else if (c.type == 64) b.setIntPref(c.name, c.value)
else b.setBoolPref(c.name, c.value)}
this._prefCache = null
break;}
break;
case "network:offline-status-changed": 
if (data == "offline"
&& this.prefBranch
&& this.prefBranch.getBoolPref("offline")
&& this.prefBranch.getBoolPref("offline.forget")) {
var svr = Cc["@mozilla.org/messenger/account-manager;1"].getService(Ci.nsIMsgAccountManager).allServers
for (var i = 0; i < svr.Count(); ++i) {
var s = svr.QueryElementAt(i, Ci.nsIMsgIncomingServer)
s.forgetSessionPassword()
s.closeCachedConnections()}
svr = Cc["@mozilla.org/messengercompose/smtp;1"].getService(Ci.nsISmtpService).smtpServers
while (svr.hasMoreElements()) {
var s = svr.getNext().QueryInterface(Ci.nsISmtpServer)
s.password = ""}}
break}},prefLoad: function () {
var AM = Cc["@mozilla.org/messenger/account-manager;1"].getService(Ci.nsIMsgAccountManager)
var pjs = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("PrefF", Ci.nsIFile)
var ac = null, warn = false
for (var i = 0; i < 4; ++i) {
try {ac = AM.accounts.Count()} catch (ex) {}
if (ac || i == 3) break
switch (i) {
case 0:
var pf = pjs
break
case 1:
var pb0 = pjs.parent.clone(), pb1 = pjs.parent.clone()
pb0.append("prefs.bk0"), pb1.append("prefs.bk1")
var swap = pb0.exists() && pb1.exists() && pb1.lastModifiedTime > pb0.lastModifiedTime
pf = swap? pb1 : pb0
warn = true
break
case 2:
pf = swap? pb0 : pb1
break}
if (!pf.exists()) continue
if (i > 0) {
if (pjs.exists()) try {pjs.remove(false)} catch (ex) {}
try {pf.copyTo(pjs.parent, pjs.leafName)} catch (ex) {}}
AM.UnloadAccounts()
this.pref.resetPrefs()
try {
this.pref.readUserPrefs(null)
AM.LoadAccounts()} catch (ex) {}}
if (ac && warn) {
var bn = Cc["@mozilla.org/intl/stringbundle;1"].getService(Ci.nsIStringBundleService).createBundle("chrome://mailtweak/locale/prefcache.properties")
Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService).alert(null, bn.GetStringFromName("title"), bn.GetStringFromName("warning"))}
this.prefBranch = this.pref.getBranch("extension.mailtweak.")},prefSave: function (isMain) {
var AM = Cc["@mozilla.org/messenger/account-manager;1"].getService(Ci.nsIMsgAccountManager)
try {var ac = AM.accounts.Count()} catch (ex) {var ac = 0}
if (ac == 0) return
var pf = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("PrefD", Ci.nsIFile)
pf.append("prefs.bk" + (isMain? "0":"1"))
this.pref.savePrefFile(pf)},reload: function (doMail, doAB, doComp) {
this.applyStyle()
var WW = Cc["@mozilla.org/embedcomp/window-watcher;1"].getService(Ci.nsIWindowWatcher)
var a = []
if (doMail) a.push({type: "mail:3pane", url: "chrome://messenger/content/messenger.xul"})
if (doAB) a.push({type: "mail:addressbook", url: "chrome://messenger/content/addressbook/addressbook.xul"})
if (doComp) a.push({type: "msgcompose", url: null})
const feat = "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar"
for each (var spec in a) {
var enum = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator).getEnumerator(spec.type)
if (!enum.hasMoreElements()) spec.url = ""
else while (enum.hasMoreElements()) {
var w = enum.getNext()
w.close()
if (spec.url && !enum.hasMoreElements())
WW.openWindow(null, spec.url, "_blank", feat, null )}}},get deferrer () {return Deferrer},get disconnecter () {return Disconnecter},get capitalizer () {return Capitalizer},get pathguard () {return PathGuard},get personalizer () {return Personalizer},get replymanager () {return ReplyManager},get tagtools () {return TagTools},get timedsend () {return TimedSend},_replyground: "",// nsICommandLineHandler...
get helpInfo () {return " -internal <function> Call internal function\n"},handle: function (cl) {
if (cl.state == 0) return
ok = cl.handleFlag("quit", false)
if (!ok) return
var enum = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator).getEnumerator(null)
while (enum.hasMoreElements()) {
var w = enum.getNext()
if ("goQuitApplication" in w) {
w.setTimeout(w.goQuitApplication, 0)
break}}},toString: function () {return "[object MailTweakService]"}}
Capitalizer = {
_caps: function (t) {
return t.match(/([ -])|([^ -]+)/g).map(function (w) {
if (w.length < 2) return w
if (w == "id") return "ID"
if (w == "in" || w == "as") return w
var c = w.charAt(0)
return c.toUpperCase() + w.substr(1)}).join("")},_nit: function (t) {
return t.charAt(0).toUpperCase() + t.substr(1)},load: function (document) {
var box = document.getElementById("expandedHeadersBox")
var ee = box.getElementsByTagName("label")
for (var i = 0, e; e = ee[i]; i++) {
var v = e.getAttribute("value")
if (v) e.setAttribute("value", this._caps(v).replace(/\s+$/, ":"))}
ee = box.getElementsByTagName("toolbarbutton")
for (var i = 0, e; e = ee[i]; i++) {
var v = e.getAttribute("label")
if (v) e.setAttribute("label", this._caps(v))
v = e.getAttribute("tooltiptext")
if (v) e.setAttribute("tooltiptext", this._nit(v))}
ee = box.getElementsByTagName("button")
for (var i = 0, e; e = ee[i]; i++) {
var v = e.getAttribute("label")
if (v) e.setAttribute("label", this._caps(v))}
ee = box.getElementsByTagName("menuitem")
for (var i = 0, e; e = ee[i]; i++) {
var v = e.getAttribute("label")
if (v) e.setAttribute("label", this._caps(v))
v = e.getAttribute("tooltiptext")
if (v) e.setAttribute("tooltiptext", this._nit(v))}
with (document.styleSheets[2])
insertRule('toolbar .hdrArchiveButton, .hdrArchiveButton#archive {'
+ 'list-style-image: url(chrome://messenger/skin/icons/mail-toolbar-small.png);'
+ '-moz-image-region: rect(0px 320px 16px 304px);}', cssRules.length - 1),insertRule('toolbar .hdrJunkButton, .hdrJunkButton#junk {'
+ 'list-style-image: url(chrome://messenger/skin/icons/mail-toolbar-small.png);'
+ '-moz-image-region: rect(0px 144px 16px 128px);}', cssRules.length - 1)},multiload: function (document) {
var doc = document.getElementById('multimessage').contentDocument
ee = doc.body.getElementsByTagName("button")
for (var i = 0, e; e = ee[i]; i++) {
var v = e.getAttribute("label")
if (v) e.setAttribute("label", this._caps(v))}
with (doc.styleSheets[1])
insertRule('#archive {'
+ 'list-style-image: url(chrome://messenger/skin/icons/mail-toolbar-small.png) !important;'
+ '-moz-image-region: rect(0px 320px 16px 304px);} !important', cssRules.length - 1),insertRule('#junk {'
+ 'list-style-image: url(chrome://messenger/skin/icons/mail-toolbar-small.png);'
+ '-moz-image-region: rect(0px 144px 16px 128px);}', cssRules.length - 1),insertRule('.button-text {-moz-margin-start: 2px !important;}', cssRules.length - 1)}}
Deferrer = {
AM: Cc["@mozilla.org/messenger/account-manager;1"].getService(Ci.nsIMsgAccountManager),SL: Cc["@mozilla.org/messengercompose/sendlater;1"].getService(Ci.nsIMsgSendLater),MR: Cc["@mozilla.org/messenger;1"].createInstance(Ci.nsIMessenger),outbox: null,pending: null,timer: Cc["@mozilla.org/timer;1"].createInstance(Ci.nsITimer),account: "",msgKey: "",mode: 0,pref: null,init: function () {
this.pref = MailTweakService.pref.getBranch("extension.mailtweak.defer")
if (!this.pref.getBoolPref("")) return
this.outbox = this.SL.getUnsentMessagesFolder(null)
try {this.pending = this.outbox.getChildNamed("Deferred")} catch (ex) {}
if (!this.pending) return
this.timer.init(this, 5000, 0)},observe: function (timer, topic, zzz) {
this.timer.cancel()
var pend = Deferrer.pending
if (!pend) return
var mm = pend.messages, first = null, when = 0
while (mm.hasMoreElements()) {
var m = mm.getNext().QueryInterface(Ci.nsIMsgDBHdr)
if (when == 0 || when > m.dateInSeconds) when = m.dateInSeconds, first = m}
if (!first) return
var d = (new Date).getTime()
var wait = when - Math.floor(d / 1000)
if (wait > 10) Deferrer.timer.init(Deferrer, wait * 1000, 0)
else Deferrer.process(first)},process: function (msg) {
var uri = msg.folder.getUriForMsg(msg)
this.account = msg.accountKey
this.msgKey = msg.messageKey
this.MR.messageServiceFromURI(uri).streamMessage(uri, this, null, null, false, "", false )},onStartRequest: function () {this._data = ""},onStopRequest: function () {
var i = this._data.indexOf("X-MailTweak-Defer:")
if (this._data.charAt(i + 19) == "0") {
this.mode = 0
var k = this.account, dest, flags = 0
if (k) dest = Deferrer.AM.getAccount(k)
else dest = Deferrer.AM.defaultAccount
dest = dest.incomingServer.rootFolder.getFolderWithFlags(0x1000)
dest.biffState = 0
var tag = this.pref.getCharPref(".tag")}
else {
this.mode = 1
var dest = this.outbox, flags = 1, tag = ""}
this._data = this._data.replace(/\r\nX-MailTweak-Defer: \d/g, "").replace(/\r\nX-Mozilla-Status: \d+/, "\r\nX-Mozilla-Status: 0000")
if (this.mode == 1)
this._data = this._data.replace(/\r\nX-Date-Was: [^\r]+/g, "")
var tmp = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile)
tmp.append("temp.eml")
tmp.createUnique(0, 0777)
var os = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream)
os.init(tmp, 0x2a, 0777, 0)
os.write(this._data, this._data.length)
os.flush()
os.close()
Components.classes["@mozilla.org/messenger/messagecopyservice;1"].getService(Components.interfaces.nsIMsgCopyService).CopyFileMessage(tmp.clone(), dest, null, false, flags, tag, this, null)},onDataAvailable: function (req, ctx, ins, ofs, n) {
var ss = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream)
ss.init(ins)
this._data += ss.read(ss.available())},QueryInterface: function (aIId, instance) {
if (aIId.equals(Components.interfaces.nsIStreamListener)
|| aIId.equals(Components.interfaces.nsICopyServiceListener)
|| aIId.equals(Components.interfaces.nsISupports)) return this
throw Components.results.NS_ERROR_NO_INTERFACE},OnStopCopy: function (status) {
if (status != 0) {
Components.utils.reportError("MailTweak deferrer copy error: " + status)
return}
try {
this.pending.getDBFolderInfoAndDB({}).DeleteMessage(this.msgKey, null, true)} catch (ex) {Components.utils.reportError(ex)}
this.msgKey = ""
this.account = ""
if (this.mode == 1) this.SL.sendUnsentMessages(null)
this.observe()},OnProgress: function () {},OnStartCopy: function () {},SetMessageKey: function (k) {},toString: function () "[object MailTweak Deferrer]"}
Disconnecter = {
enabled: true,_tally: 0,_timer: Cc["@mozilla.org/timer;1"].createInstance(Ci.nsITimer),await: function (state) {
if (state == "true") {
if (this._tally == 0) return
if (--this._tally == 0) this._timer.ithis._nit(
this,MailTweakService.prefBranch.getIntPref("disconnect.delay") * 1000,0)}
else if (!state) {
this._timer.cancel()
this._tally++}},observe: function () {
if (!Disconnecter.enabled) return
var DS = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties)
var name = MailTweakService.prefBranch.getCharPref("disconnect.script")
var scr = DS.get("PrefF", Ci.nsIFile).parent
scr.append(name)
if (!scr.exists()) {
scr = DS.get("ARes", Ci.nsIFile).parent
scr.append(name)}
if (scr.exists()) try {
var proc = Cc["@mozilla.org/process/util;1"].createInstance(Ci.nsIProcess)
proc.init(scr)
proc.run(false, null, 0)} catch (ex) {}
if (MailTweakService.prefBranch.getBoolPref("disconnect.offline")) {
var ww = Cc["@mozilla.org/embedcomp/window-watcher;1"].getService(Ci.nsIWindowWatcher).getWindowEnumerator()
while (ww.hasMoreElements()) {
var w = ww.getNext().QueryInterface(Ci.nsIDOMWindow)
if ("MailOfflineMgr" in w) {
if (w.MailOfflineMgr.isOnline()) w.MailOfflineMgr.toggleOfflineStatus()
break}}}}}
PathGuard = {
PS: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),guard: function (window, pref, callback, arg) {
this._window = window
this._pref = this.PS.getBranch(pref)
this._callback = callback
this._arg = arg
var f = null
try {f = this._pref.getComplexValue("", Components.interfaces.nsILocalFile)} catch (ex) {}
if (!f) {
this._retry = 0
this.retry()
return}
var my = this
var verify = {
run: function () {
my._ok = f.exists()
my._retry = 0}}
my._ok = false
my._retry = 100
if (Components.classes["@mozilla.org/thread-manager;1"]) {
my._thread = Components.classes["@mozilla.org/thread-manager;1"].getService().newThread(0)
my._thread.dispatch(verify, 0)}
else {
my._thread = Components.classes["@mozilla.org/thread;1"].createInstance(Components.interfaces.nsIThread)
my._thread.init(verify, 0, 0, 0, 0)}
window.setCursor("wait")
window.setTimeout(my.retry, 20)},get fallback () {
var f = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile)
if (f.parent) f = f.parent
if (f.parent) f = f.parent
return f.parent? f.parent : f},retry: function () {
var my = PathGuard
if (--my._retry > 0) my._window.setTimeout(my.retry, 20)
else {
// try {my._thread.shutdown()} catch (ex) {} HANGS!
my._window.setCursor("auto")
if (!my._ok) my._pref.setComplexValue("", Components.interfaces.nsILocalFile, my.fallback)
if (my._callback) my._callback.call(my._window, my._arg)}}}
Personalizer = {
IOS: Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService),MMS: Cc["@mozilla.org/messenger/services/session;1"].getService(Ci.nsIMsgMailSession),MSL: Cc["@mozilla.org/messengercompose/sendlater;1"].getService(Ci.nsIMsgSendLater),timer: Cc["@mozilla.org/timer;1"].createInstance(Ci.nsITimer),make_active: false,parent: null,csvFile: null,activate: function (id) {
this._mark = MailTweakService.prefBranch.getCharPref("personal.marker")
this._uniqueid = MailTweakService.prefBranch.getBoolPref("personal.uniqueid")
this._csv_charset = MailTweakService.prefBranch.getCharPref("personal.csv.charset")
this._csv_to = MailTweakService.prefBranch.getCharPref("personal.csv.to")
this._umf = this.MSL.getUnsentMessagesFolder(id)
this._msgid = {}
var enum = this._umf.messages || this._umf.getMessages(null)
while (enum.hasMoreElements()) {
var msg = enum.getNext().QueryInterface(Ci.nsIMsgDBHdr)
this._msgid[msg.messageId] = true}
this._observercount = 50
this.timer.init(this, 100, 1)},observe: function () {
var enum = this._umf.messages || this._umf.getMessages(null)
while (enum.hasMoreElements()) {
var msg = enum.getNext().QueryInterface(Ci.nsIMsgDBHdr)
if (!this._msgid[msg.messageId]) {
this.timer.cancel()
this.process(msg)
break}}
if (--this._observercount == 0) this.timer.cancel()},process: function (msg) {
this._msg = msg
if (msg.Charset) {
this._msgConv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Ci.nsIScriptableUnicodeConverter)
this._msgConv.charset = msg.Charset}
else this._msgConv = null
if (this.csvFile) {
this._recipient = []
this._card = []
this.csvLoad()
this.csvFile = null}
else {
this._recipient = msg.recipients.split(",")
this._card = []
for (var i = 0; i < this._recipient.length; ++i) {
var adr = this._recipient[i]
if (adr.indexOf("<") >= 0) adr = adr.match(/<(.*)>/)[1]
else adr = adr.replace(/^, |^ ,|^,|^ /, "")
try {this._card.push(this.abSearch(adr))}
catch (ex) {
this.error("abook", this._recipient[i])
return}}}
var url = this.MMS.ConvertMsgURIToMsgURL(this._umf.generateMessageURI(msg.messageKey), null)
var cha = this.IOS.newChannel(url, "", null)
cha.asyncOpen(this.reader, null)},abSearch: function (addr) {
var abks = Cc["@mozilla.org/rdf/rdf-service;1"].getService(Ci.nsIRDFService).GetResource("moz-abdirectory://").QueryInterface(Ci.nsIAbDirectory).childNodes
while (abks.hasMoreElements()) {
var abk = abks.getNext().QueryInterface(Ci.nsIAbDirectory)
if (!abk.isRemote && !abk.isMailList) {
var cds = abk.childCards
if (cds.first) {
try {
cds.first()
while (true) {
var cd = cds.currentItem().QueryInterface(Ci.nsIAbCard)
if (cd.primaryEmail == addr) return cd
cds.next()}} catch (ex) {continue}}
else {
while (cds.hasMoreElements()) {
var cd = cds.getNext().QueryInterface(Ci.nsIAbCard)
if (cd.primaryEmail == addr) return cd}}}}
throw null},csvLoad: function () {
var fs = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream)
fs.init(this.csvFile, 1, 0, 0)
var ss = Cc["@mozilla.org/scriptableinputstream;1"].createInstance(Ci.nsIScriptableInputStream)
ss.init(fs)
var rr = ss.read(ss.available())
ss.close(), fs.close()
if (this._csv_charset) {
var uc = Cc["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Ci.nsIScriptableUnicodeConverter)
uc.charset = this._csv_charset
rr = uc.ConvertToUnicode(rr)}
rr = rr.split(/\r\n|\r|\n/)
var field = null
for each (var r in rr) {
if (r == "") continue
var a = r.match(/(?:^|,)(\"(?:[^\"]+|\"\")*\"|[^,]*)/g)
if (field) {
var cd = {}, rp = ""
for (var i = 0; i < a.length; ++i) {
var v = a[i].replace(/^,"|^,|^"|"$/g, "").replace(/""/g, '"')
cd[field[i]] = v
if (!rp) {
if (this._csv_to) {
if (field[i] == this._csv_to) rp = v}
else {
if (a[i].indexOf("@") >= 0) rp = v}}}
this._recipient.push(rp)
this._card.push(cd)}
else {
field = []
for (var i = 0; i < a.length; ++i) {
var v = a[i].replace(/^,"|^,|^"|"$/g, "").replace(/""/g, '"').replace(/\s/g, "_")
field.push(v)}}}},reader: {
onDataAvailable: function (req, ctx, ins, ofs, cnt) {
var sis = Cc["@mozilla.org/scriptableinputstream;1"].createInstance(Ci.nsIScriptableInputStream)
sis.init(ins)
Personalizer._eml += sis.read(sis.available())},onStartRequest: function () {Personalizer._eml = ""},onStopRequest: function () {Personalizer.clone()}},clone: function () {
// dump(">> to: " + this._mark + "_fullEmail" + this._mark + "\n")
this._eml = this._eml.replace(/\nTo:.*\r(\n\s.*\r)*/i, "\nTo: " + this._mark + "_fullEmail" + this._mark + "\r").replace(/\nCC:.*\r/i, "").replace(/\nBCC:.*\r(\n\s.*\r)*/i, "\nBCC: " + this._mark + "_fullEmail" + this._mark + "\r")
if (Ci.nsIFileSpec) var f = null
else {
var f = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("TmpD", Ci.nsILocalFile)
f.append("personal.eml")
f.createUnique(0, 0700)}
for (var i = 0; i < this._card.length; ++i) this.clone1(i, f)
if (f) f.remove(false)
this._umf.getDBFolderInfoAndDB({}).DeleteMessage(this._msg.messageKey, null, true)
var PS = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService)
var send = PS.confirmEx(
this.parent,this.string("label"),this.string("sendnow").replace(/#/, this._card.length),0x7F7F,this.string("sendbtn"),this.string("leavebtn"),"",null,{})
this.parent = null
if (send == 0) {
if (this.MSL.SendUnsentMessages) this.MSL.SendUnsentMessages(this._identity)
else this.MSL.sendUnsentMessages(this._identity)}},clone1: function (n, f) {
var sis = Cc["@mozilla.org/io/string-input-stream;1"].createInstance(Ci.nsIStringInputStream)
var text = this.modify(this._eml, n)
if (f) {
var s = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream)
s.init(f, 0x24, 0700, 0)
s.write(text, text.length)
s.close()
Cc["@mozilla.org/messenger/messagecopyservice;1"].getService(Ci.nsIMsgCopyService).CopyFileMessage(f.clone(), this._umf, null, false, 0, "", null, null)}
else {
f = {
inputStream: sis,openStreamForReading: function () {sis.setData(text, text.length)},closeStream: function () {sis.close()},QueryInterface: function (iid) {
if (iid.equals(Ci.nsIFileSpec) || iid.equals(Ci.nsISupports)) return this
throw Cr.NS_NOINTERFACE}}
Cc["@mozilla.org/messenger/messagecopyservice;1"].getService(Ci.nsIMsgCopyService).CopyFileMessage(f, this._umf, null, false, 0, null, null)}},modify: function (eml, n) {
// also avoid processing fields in attachments!
var cs = this._msgConv
var mk = ""
for (var i = 0; i < this._mark.length; ++i) {
var c = this._mark.charAt(i)
mk += /[\\\^\$\*\+\?\(\)\|\{\}\[\]]/.test(c)? "\\" + c : c}
var text = eml
var tok = eml.match(new RegExp(mk + "\\w+" + mk, "g"))
var rmv = new RegExp(mk, "g")
for (var i = 0; i < tok.length; ++i) {
var k = tok[i].replace(rmv, ""), cd = this._card[n]
var sub = k in cd? cd[k]
: "getProperty" in cd? cd.getProperty(k.charAt(0).toUpperCase() + k.substr(1), "")
: ""
if (!sub && tok[i] == this._mark + "_fullEmail" + this._mark) sub = this._recipient[n]
if (cs) sub = cs.ConvertFromUnicode(sub)
text = text.replace(new RegExp(tok[i].replace(rmv, mk), "g"), sub)}
if (this._uniqueid) {
var m = text.match(/Message-ID: (\S+)/)
if (m) {
var id = m[1].replace(/@/, "." + n + "@")
text = text.replace(/Message-ID: (\S+)/, "Message-ID: " + id)}}
return text},error: function (msg, sub) {
var PS = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService)
PS.alert(
this.parent,this.string("error"),this.string(msg).replace(/#/, sub) + "\n" + this.string("unsent"))
this.parent = null},_strings: null,string: function (key) {
if (!this._strings) this._strings = Cc["@mozilla.org/intl/stringbundle;1"].getService(Ci.nsIStringBundleService).createBundle("chrome://mailtweak/locale/compose.properties")
try {var s = this._strings.GetStringFromName(key)}
catch (ex) {var s = (dump("no string " + key + "\n"), "?")}
return s},toString: function () {return "[object MailTweak Personalizer]"}}
ReplyManager = {
_window: null,_folder: null,_msg: null,_index: -1,collected: false,init: function (wdw, folder, msgs) {
this._window = wdw
this._folder = folder
this._msg = msgs
this._index = -1
this.next(null)},next: function (wdw) {
var m = this._msg && this._msg[++this._index]
if (m) {
var w = this._window, f = this._folder
if (f) this._window.setTimeout(function () {
w.ComposeMessage(6, 0, f, [m])}, 0)
else this._window.setTimeout(function () {
var fields = Cc["@mozilla.org/messengercompose/composefields;1"].createInstance(Ci.nsIMsgCompFields)
fields.to = m
var p = Cc["@mozilla.org/messengercompose/composeparams;1"].createInstance(Ci.nsIMsgComposeParams)
p.type = 1
p.format = 0
p.composeFields = fields
Cc["@mozilla.org/messengercompose;1"].getService(Ci.nsIMsgComposeService).OpenComposeWindowWithParams(null, p)}, 0)}
else
this._window = null, this._folder = null, this._msg = null, this._index = -1}}
TagTools = {
TS: Cc["@mozilla.org/messenger/tagservice;1"].getService(Ci.nsIMsgTagService),_sheet: "",poolOK: null,// called after Options dialog changes the tags...
change: function () {
this.init()
var enum = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator).getEnumerator("mail:3pane")
while (enum.hasMoreElements()) {
var w = enum.getNext()
this.load(w.document, true)
w.document.getElementById("threadTree").treeBoxObject.invalidate()}},init: function () {
var pool = MailTweakService.prefBranch.getCharPref("tagtools.pool")
if (pool) this.loadPool(pool)
const rgb = /#(..)(..)(..)/
this._sheet = "data:text/css,"
var gray = MailTweakService.prefBranch.getIntPref("tagtools.gray")
var tt = this.TS.getAllTags({})
for (var i = 0; i < tt.length; ++i) {
var c = tt[i].color, p = 'lc-' + c.substr(1)
if (c) {
var m = c.match(rgb)
if (!m) dump("bad rgb: " + c + "\n"), m = [0, 0, 0]
var b = (parseInt(m[1], 16) / 2 + parseInt(m[2], 16) + parseInt(m[3], 16) / 3) / 4.675
this._sheet += 'treechildren::-moz-tree-cell-text%28' + p + '%29,'
+ '.' + p + ':not%28[_moz-menuactive]%29'
+ '{color:' + c + ';}'
+ 'treechildren::-moz-tree-row%28' + p + ',selected,focus%29'
+ '{background-color:' + c + ';}'
+ 'treechildren::-moz-tree-cell-text%28' + p + ',selected,focus%29'
+ '{color:' + (b > gray? 'black':'white') + ';}'}}},load: function (doc, reload) {
if (reload) doc.styleSheets[1].deleteRule(0)
doc.styleSheets[1].insertRule('@import url(' + this._sheet + ');', 0)},loadPool: function (pool) {
this.poolOK = false
var f = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile)
try {f.initWithPath(pool)} catch (ex) {return}
var s = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream)
try {s.init(f, 1, 4, 4)} catch (ex) {return}
var DP = Cc["@mozilla.org/xmlextras/domparser;1"].createInstance(Ci.nsIDOMParser)
try {var doc = DP.parseFromStream(s, null, s.available(), "text/xml")}
catch (ex) {var doc = null}
s.close()
if (!doc) return
var tagset = doc.documentElement
if (tagset.localName != "tagset") return
var tags = doc.getElementsByTagName("tag")
if (tags.length == 0) return
var tt = this.TS.getAllTags({}), TSkey = {}
for each (var t in tt) TSkey[t.key] = t
var done = {}
for (var i = 0; i < tags.length; ++i) {
var tag = tags[i]
if (tag.parentNode != tagset) continue
var key = tag.getAttribute("key")
if (!key || done[key]) continue
var color = tag.getAttribute("color") || "#000000"
if (color != TSkey[key].color) this.TS.setColorForKey(key, color)
var ordinal = tag.getAttribute("ordinal")
if (ordinal != TSkey[key].ordinal) this.TS.setOrdinalForKey(key, ordinal)
var name = tag.firstChild.nodeValue || key
if (name != TSkey[key].tag) this.TS.setTagForKey(key, name)
TSkey[key] = null
done[key] = true}
for (var k in TSkey) if (TSkey[k]) this.TS.deleteKey(k)
this.poolOK = true}}
TimedSend = {
MSL: Cc["@mozilla.org/messengercompose/sendlater;1"].getService(Ci.nsIMsgSendLater),_timer: Cc["@mozilla.org/timer;1"].createInstance(Ci.nsITimer),_running: false,set enabled (ok) {
if (ok === this._running) return
if (!MailTweakService.prefBranch.getBoolPref("collect.retry")) return
this._running = ok
var t = MailTweakService.prefBranch.getIntPref("collect.delay")
if (t <= 0) return
if (ok) this._timer.init(this, t * 1000, 1)
else this._timer.cancel()},observe: function () {
if (this.MSL.SendUnsentMessages) this.MSL.SendUnsentMessages(null)
else this.MSL.sendUnsentMessages(null)
var f = this.MSL.getUnsentMessagesFolder(null)
if (f.Count) {
if (f.Count() == 0) this.enabled = false}
else {
if (f.getTotalMessages(false) == 0) this.enabled = false}}}