/* MailTweak internal component - Copyright (C) 2007, 2010 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://mailtweak.mozdev.org/ */
Components.utils.import("resource://mailtweak/defer-preset.js")
date = null
pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService)
SDF = Components.classes["@mozilla.org/intl/scriptabledateformat;1"].getService(Components.interfaces.nsIScriptableDateFormat)
onload = function () { try {
var x2 = document.documentElement.getButton("extra2")
x2.hidden = !window.arguments[0].immed
var a = []
var ppref = pref.getBranch("extension.mailtweak.defer.preset")
var pp = ppref.getChildList("", {})
for each (var p in pp) {
var s = p.split("."), v
if (s[1] == "label") {
v = ppref.getComplexValue(p, Components.interfaces.nsISupportsString).data
if (v.indexOf("chrome://") == 0)
v = ppref.getComplexValue(p, Components.interfaces.nsIPrefLocalizedString).data}
else
v = ppref.getCharPref(p)
var i = s[0]
if (!a[i]) a[i] = {}
a[i][s[1]] = v}
var box = document.getElementById("presets")
for each (var p in a) if (p.label && p.spec) with (box.appendChild(document.createElement("button"))) {
setAttribute("label", p.label)
setAttribute("value", p.spec)
var d = (new MailTweak_DeferPreset(p.spec)).when
setAttribute("tooltiptext",SDF.FormatDateTime("", 1, 2, d.getFullYear(), d.getMonth() + 1, d.getDate(), d.getHours(), d.getMinutes(), 0))}
if (!box.firstChild) box.nextSibling.hidden = true
var d = MailTweak_DeferPreset.default
if (d) date.value = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate()
change()
// set default time...
if (!d) d = (new MailTweak_DeferPreset(
pref.getBranch("extension.mailtweak.defer.").getCharPref("time"))).when
time.value = d.getHours() + ":" + d.getMinutes()
allow()
// adjust date picker dynamically...
date.addEventListener("change", change, false)
date.addEventListener("keypress", keypress, false)
date.addEventListener("click", click, true)} catch (ex) {dump("onload error - " + ex + " " + ex.lineNumber + "\n")}}
accept = function () { try {
var dlg = window.arguments[0]
dlg.ok = true
if (!dlg.time) {
var d = allow()
dlg.time = d
MailTweak_DeferPreset.default = d}
return Boolean(dlg.time)} catch (ex) {dump("accept error - " + ex + "\n")}}
allow = function () {
var d = new Date(date.dateValue)
d.setHours(time.hour)
d.setMinutes(time.minute)
d.setSeconds(0)
d.setMilliseconds(0)
var ok = d.getTime() - (new Date).getTime() > 10000
document.documentElement.getButton("accept").disabled = !ok
return ok? d : null}
preset = function (v) {
window.arguments[0].time = (new MailTweak_DeferPreset(v)).when
accept()
close()}
immediate = function () {
window.arguments[0].time = new Date
accept()
close()}
pretty = function () {
date = document.getElementById("date")
time = document.getElementById("time")
var rows = document.getAnonymousElementByAttribute(date, "anonid", "datebox")
var row = rows.lastChild
row.hidden = row.firstChild.value == ""
row = row.previousSibling
row.hidden = row.firstChild.value == ""
row = rows.firstChild.nextSibling
var d = date._displayedDate
d = new Date(d.getFullYear(), d.getMonth(), 0)
d = d.getDate()
var elem = row.lastChild
while (elem) {
elem = elem.previousSibling
if (elem) {
if (elem.value == "") {
elem.setAttribute("dim", "true")
elem.value = d--}
else elem.removeAttribute("dim")}}
row = rows.lastChild
while (row.hidden) row = row.previousSibling
d = 1
elem = row.firstChild
while (elem) {
elem = elem.nextSibling
if (elem) {
if (elem.value == "") {
elem.setAttribute("dim", "true")
elem.value = d++}
else elem.removeAttribute("dim")}}
row = row.previousSibling
elem = row.firstChild
while (elem) {
elem = elem.nextSibling
if (elem) elem.removeAttribute("dim")}}
addEventListener("monthchange", pretty, false)
click = function (event) { try {
if (event.button != 0 || date.disabled || date.readOnly) return
var lbl = event.originalTarget
if (lbl.className == "datepicker-gridlabel" && lbl.hasAttribute("dim")) {
var d = date._displayedDate, m = d.getMonth(), v = lbl.value
m += v > 15? -1 : 1
date.value = d.getFullYear() + "-" + (m + 1) + "-" + v
change()
allow()
event.stopPropagation()
event.preventDefault()}} catch (ex) {dump(ex + "\n")}}
change = function (event) {
document.getElementById("show-date").value = date.dateValue.toLocaleDateString()
if (!event) return
var lbl = event.target.selectedItem, v = lbl.value
if (lbl.hasAttribute("dim")) {
var rr = date.dateField.childNodes
for (var i = 3, r; r = rr[i]; ++i) {
var ee = r.childNodes
for (var j = 0, e; e = ee[j]; ++j) {
if (e.value == v) {
date.selectedItem = e
break}}}}
allow()}
keypress = function (event) {
var k = event.keyCode
if (k == event.DOM_VK_HOME || k == event.DOM_VK_END) {
var d = date._displayedDate
if (k == event.DOM_VK_HOME) d.setDate(1)
else d = new Date(d.getFullYear(), d.getMonth() + 1, 0)
date.value = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate()
change()}}